; Simple Nick Completer
; Contact: debian_ on #skene on irc.skene.net
;
; A simple nick completer with nick completion suppot
; Syntax: <nick or first few chacters of nick>: message
;
; Example: deb: hello world
; Will return: debian_: hello world


on *:input:#:{
  ; Checks to see if input is a command.
  if (/* !iswm $1) {
    ; Checks to see if $1 is using nickcompleter syntax, and that there is a nick that matches segment provided.
    if (*_ iswm $1) && ($wildnick($remove($1,_)) ison $chan) { msg $target $wildnick($remove($1,_)) $+ :  $2- }
    ; If not, msg as a normal sentence.
    else { msg $target $1- }
    haltdef
  }
}

; $wildnick returns first matching nick in active window
; Feel free to use in your script
; Syntax: $wildnick(<first few chr's of nickname>)

alias wildnick {
  var %x = 1
  while (%x <= $nick($active,0,a)) {
    if ($left($nick($active,%x,a),$len($1)) == $1) { return $nick($active,%x,a) }
    inc %x
  }
  return $null
}
